// ------ Display Window Server v2.06 Connect ---------------------------------
//
// Copyright 06/2003 by Al Getz
//
// Free for all Euphoria users to use.
//
// This doesnt have the more recent procedure calls yet.
//
// This is the C++ include file for connecting and printing to the
// Display Window server window.
// To convert to C instead of C++, rename this file to "Connect.c"
//
// The server window is an automatically scrolling window that
// runs in it's own process and so doesnt crash if your program
// crashes.
// The server window can be used to display text while your
// program runs and uses very little processor time (if any)
// while it sits idle in the background (no text sent to it).
// When text is sent, it displays very quickly and then returns
// to the calling program.
// You can also have multiple clients connected at the same time
// so that you can monitor the progress of a number of programs
// in the same server window.  This is most handy when debugging.
// The only way you can crash the server window is to crash the
// whole machine.
//
//
//
//  To use:
//
//  Include this file in the file with your WinMain like this:
//    #include "connect.cpp" 
//  or
//    #include "connect.c"
//  after renaming the file.
//
//  Call this from WinMain to connect:
//    InitializeServerConnection()
//
//  To print something, call this after connecting:
//    ServerPrint("Message Text to get displayed")
//


//#define __cplusplus

long CurrentProcessId;
long RegisteredMessage01;
HWND hServer;
long HANDLE_FLAG_WAIT=0xFFFFFFFF;

typedef struct DataStruct
{
  long code;
  long function;
  long stringlength;
  long zero;
  char string[2048];
}MyData;


void ServerPrint(char* message)
    //this does the actual printing
{
  long len=strlen(message);
  MyData DS;

  if (hServer==0)
    return;

  if (len>2020)
    len=2020;

  DS.code=3;
  DS.function=1;
  DS.stringlength=len; //the string length <=2020
  DS.zero=0;
  strncpy(DS.string,message,len);

  SendMessage(hServer,RegisteredMessage01,CurrentProcessId,(long)&DS);
}




void InitializeServerConnection(void)
    //Try to connect to a display server that is already open.
{
  long code=0x754A1C1E,hWnd=0,verified=0,t1;
  unsigned int RM;
  time_t ptime;

  CurrentProcessId=GetCurrentProcessId();

  RegisteredMessage01=RegisterWindowMessage("DisplayWindowServer{02AE8B00-CC8C-11d7-BCA1-00A0CC75AD21}");
  if (RegisteredMessage01<1)
    RegisteredMessage01=0x0000BFFF;
  RM=RegisteredMessage01;

  hServer=FindWindow("DisplayWindowServer{02AE8B00-CC8C-11d7-BCA1-00A0CC75AD21}",0);
  if (hServer!=0)
  {
    t1=time(&ptime)+3; //set timeout period just in case
    while (time(&ptime)<t1)
    {
      hWnd=SendMessage(hServer,RM,1,1);
      if (hWnd!=HANDLE_FLAG_WAIT)
        break;
      else
  Sleep(100);
    }
    if (hWnd!=HANDLE_FLAG_WAIT)
      if (SendMessage(hServer,RM,1,2)==2)
        if (SendMessage(hServer,RM,code,3)==code)
          if (SendMessage(hServer,RM,1,4)==code)
            if (SendMessage(hServer,RM,1,5)==0)
              verified=1;
  }


  if (verified==1)
    //This following line can be remmed out:
    ServerPrint("__C_Client_Connected__");
  else
    hServer=0;

}


//#undef __cplusplus

